# ----------------------------------------------------------------------------------------------
# ---- Measures for security assurance by Years in Software development or in FOSS Project -----
# ----------------------------------------------------------------------------------------------
fossanalyze.measure_years <- function (saveFile=FALSE, expertType="soft", projectPhase="design", file="measure") {

# Plot constants 
if(expertType == "soft") {
    projectYearsText <- "Software development"
    xlabText <- "By years in Software development";
    yearsLab <- yearsSoftLab
} else {
    projectYearsText <- "FOSS projects"
    xlabText <- "By years in FOSS projects";
    yearsLab <- yearsFossLab
}

if(projectPhase == "design") {
    projectPhaseText <- "DESIGN"
    measures    <- designMeasures
    measuresLab <- designMeasuresLab
    fileName <- paste(file, "_design", sep = "")
    if(expertType == "soft") {
        nm_1 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[1], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[2], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[3], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[4], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[5], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	fileName <- paste(fileName, "_soft", sep = "")
    } else {
        nm_1 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[1], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[2], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[3], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[4], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[5], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	fileName <- paste(fileName, "_foss", sep = "")
    }
} else if(projectPhase == "impl") {
    projectPhaseText <- "IMPLEMENTATION"
    measures    <- implMeasures
    measuresLab <- implMeasuresLab
    fileName <- paste(file, "_impl", sep = "")
    if(expertType == "soft") {
        nm_1 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[1], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[2], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[3], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[4], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[5], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	fileName <- paste(fileName, "_soft", sep = "")
    } else {
        nm_1 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[1], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[2], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[3], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[4], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_IMPL_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[5], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	fileName <- paste(fileName, "_foss", sep = "")
    }
} else if(projectPhase == "test") {
    projectPhaseText <- "TESTING"
    measures <- testMeasures
    measuresLab <- testMeasureslab
    fileName <- paste(file, "_test", sep = "")
    if(expertType == "soft") {
        nm_1 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[1], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[2], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[3], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[4], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[5], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	fileName <- paste(fileName, "_soft", sep = "")
    } else {
        nm_1 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[1], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[2], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[3], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_DESIGN_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[4], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_TEST_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[5], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	fileName <- paste(fileName, "_foss", sep = "")
    }
} else {
    projectPhaseText <- "MAINTENANCE"
    measures    <- mainMeasures
    measuresLab <- mainMeasuresLab
    fileName <- paste(file, "_main", sep = "")
    if(expertType == "soft") {
        nm_1 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[1], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[2], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[3], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[4], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_SW_DVLPMENT %in% grep(yearsSoft[5], foss$RB_HOW_MANY_YEARS_SW_DVLPMENT, value=TRUE)]
	fileName <- paste(fileName, "_soft", sep = "")
    } else {
        nm_1 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[1], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_2 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[2], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_3 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[3], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_4 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[4], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	nm_5 <- foss$CB_WHICH_MEASURES_MAINTNC_PERS[foss$RB_HOW_MANY_YEARS_PARTICIPAT %in% grep(yearsFoss[5], foss$RB_HOW_MANY_YEARS_PARTICIPAT, value=TRUE)]
	fileName <- paste(fileName, "_foss", sep = "")
    }
}
fileName <- paste(fileName, "_years", sep = "")

mainText <- paste("Measures for security assurance used during \nthe ", projectPhaseText, " (by years in ", projectYearsText, ").", sep = "")
ylabText <- percenText;
legendLab <- measures

#Normirung Maximal Wert
normMax <- 100

nm_1Len <- length(nm_1)
nm_2Len <- length(nm_2)
nm_3Len <- length(nm_3)
nm_4Len <- length(nm_4)
nm_5Len <- length(nm_5)

years_1 <- c(   length(nm_1[nm_1 %in% grep(measures[1], nm_1, value=TRUE)])/nm_1Len*normMax,
		length(nm_1[nm_1 %in% grep(measures[2], nm_1, value=TRUE)])/nm_1Len*normMax,
		length(nm_1[nm_1 %in% grep(measures[3], nm_1, value=TRUE)])/nm_1Len*normMax,
		length(nm_1[nm_1 %in% grep(measures[4], nm_1, value=TRUE)])/nm_1Len*normMax,
		length(nm_1[nm_1 %in% grep(measures[5], nm_1, value=TRUE)])/nm_1Len*normMax)

years_2 <- c(   length(nm_2[nm_2 %in% grep(measures[1], nm_2, value=TRUE)])/nm_2Len*normMax,
		length(nm_2[nm_2 %in% grep(measures[2], nm_2, value=TRUE)])/nm_2Len*normMax,
		length(nm_2[nm_2 %in% grep(measures[3], nm_2, value=TRUE)])/nm_2Len*normMax,
		length(nm_2[nm_2 %in% grep(measures[4], nm_2, value=TRUE)])/nm_2Len*normMax,
		length(nm_2[nm_2 %in% grep(measures[5], nm_2, value=TRUE)])/nm_2Len*normMax)

years_3 <- c(   length(nm_3[nm_3 %in% grep(measures[1], nm_3, value=TRUE)])/nm_3Len*normMax,
		length(nm_3[nm_3 %in% grep(measures[2], nm_3, value=TRUE)])/nm_3Len*normMax,
		length(nm_3[nm_3 %in% grep(measures[3], nm_3, value=TRUE)])/nm_3Len*normMax,
		length(nm_3[nm_3 %in% grep(measures[4], nm_3, value=TRUE)])/nm_3Len*normMax,
		length(nm_3[nm_3 %in% grep(measures[5], nm_3, value=TRUE)])/nm_3Len*normMax)

years_4 <- c(   length(nm_4[nm_4 %in% grep(measures[1], nm_4, value=TRUE)])/nm_4Len*normMax,
		length(nm_4[nm_4 %in% grep(measures[2], nm_4, value=TRUE)])/nm_4Len*normMax,
		length(nm_4[nm_4 %in% grep(measures[3], nm_4, value=TRUE)])/nm_4Len*normMax,
		length(nm_4[nm_4 %in% grep(measures[4], nm_4, value=TRUE)])/nm_4Len*normMax,
		length(nm_4[nm_4 %in% grep(measures[5], nm_4, value=TRUE)])/nm_4Len*normMax)

years_5 <- c(   length(nm_5[nm_5 %in% grep(measures[1], nm_5, value=TRUE)])/nm_5Len*normMax,
		length(nm_5[nm_5 %in% grep(measures[2], nm_5, value=TRUE)])/nm_5Len*normMax,
		length(nm_5[nm_5 %in% grep(measures[3], nm_5, value=TRUE)])/nm_5Len*normMax,
		length(nm_5[nm_5 %in% grep(measures[4], nm_5, value=TRUE)])/nm_5Len*normMax,
		length(nm_5[nm_5 %in% grep(measures[5], nm_5, value=TRUE)])/nm_5Len*normMax)

colors <- c(hcl(h = c(120, 210), c = 20, l = 90, fixup = FALSE),"indianred","darkgray", "mintcream")
if(length(measures)>=6) {
    years_1 <- c(years_1, length(nm_1[nm_1 %in% grep(measures[6], nm_1, value=TRUE)])/nm_1Len*normMax)
    years_2 <- c(years_2, length(nm_2[nm_2 %in% grep(measures[6], nm_2, value=TRUE)])/nm_2Len*normMax)
    years_3 <- c(years_3, length(nm_3[nm_3 %in% grep(measures[6], nm_3, value=TRUE)])/nm_3Len*normMax)
    years_4 <- c(years_4, length(nm_4[nm_4 %in% grep(measures[6], nm_4, value=TRUE)])/nm_4Len*normMax)
    years_5 <- c(years_5, length(nm_5[nm_5 %in% grep(measures[6], nm_5, value=TRUE)])/nm_5Len*normMax)
    colors <- c(hcl(h = c(120, 210, 300), c = 20, l = 90, fixup = FALSE),"indianred","darkgray", "mintcream")
}
if(length(measures)>=7) {
    years_1 <- c(years_1, length(nm_1[nm_1 %in% grep(measures[7], nm_1, value=TRUE)])/nm_1Len*normMax)
    years_2 <- c(years_2, length(nm_2[nm_2 %in% grep(measures[7], nm_2, value=TRUE)])/nm_2Len*normMax)
    years_3 <- c(years_3, length(nm_3[nm_3 %in% grep(measures[7], nm_3, value=TRUE)])/nm_3Len*normMax)
    years_4 <- c(years_4, length(nm_4[nm_4 %in% grep(measures[7], nm_4, value=TRUE)])/nm_4Len*normMax)
    years_5 <- c(years_5, length(nm_5[nm_5 %in% grep(measures[7], nm_5, value=TRUE)])/nm_5Len*normMax)
    colors <- c(hcl(h = c(120, 210, 300, 400), c = 20, l = 90, fixup = FALSE),"indianred","darkgray", "mintcream")
}

# construct values vector
yearsVector <- c(years_1, years_2, years_3, years_4, years_5)

# add total number of members
lenVector <- c(nm_1Len, nm_2Len, nm_3Len, nm_4Len, nm_5Len)
yearsLab <- paste(yearsLab, "\n(", lenVector, " part.)", sep="")

# construct matrix to plot
plotMatrix <- matrix(yearsVector,
                nrow = length(measures), ncol = length(yearsLab), byrow = FALSE,
                dimnames = list(measures, yearsLab))

# if "saveFile", than save as png image:
if (saveFile) png(paste(fileName, "png", sep="."), width=700, height=700)

#Plot parameters
par(mai = c(0.7, 0.7, 0.7, 0)) # margin size (bottom, left, top, right) specified in inches. 
par(mgp = c(2.2, 1, 0)) # margin line for (the axis title, axis labels, axis line)
par(cex.lab = 1.2) # label size 

#Draw Plot
barplot(plotMatrix, beside = TRUE, cex.names = 1.0, axis.lty = 0,
        col=colors,
        main=mainText, ylab=ylabText, xlab=xlabText,
        legend = rownames(plotMatrix),
        ylim = c(0, normMax))
grid(0, 10)

#coof <- 6
#offs <- 2.5
#mtext(side = 1, at = c(1:length(lenVector)*coof) - offs, adj = 0.5, line = 2, text = paste("(", lenVector, " mem.)", sep=""))

# if "saveFile", stop output-redirection to file
if (saveFile) dev.off()

}

#Function call with different parameters
isSaveFile <- TRUE
fossanalyze.measure_years(isSaveFile, "soft", "design")
fossanalyze.measure_years(isSaveFile, "soft", "impl")
fossanalyze.measure_years(isSaveFile, "soft", "test")
fossanalyze.measure_years(isSaveFile, "soft", "main")

fossanalyze.measure_years(isSaveFile, "foss", "design")
fossanalyze.measure_years(isSaveFile, "foss", "impl")
fossanalyze.measure_years(isSaveFile, "foss", "test")
fossanalyze.measure_years(isSaveFile, "foss", "main")
