# --- Frage 1: What is the type of your FOSS project?
# --- works on: foss$RB_TYPE_OF_PROJECT
fossanalyze.type_of_project <- function (saveFile=FALSE, file="type_of_project") {

nm <- foss$RB_TYPE_OF_PROJECT
nmLen <- length(nm)

# construct values vector
typesVector <- c(length(nm[nm %in% grep(projTypes[1], nm, value=TRUE)]),
         length(nm[nm %in% grep(projTypes[2], nm, value=TRUE)]),
         length(nm[nm %in% grep(projTypes[3], nm, value=TRUE)]))

#Normirung Maximal Wert
normMax <- 100

typesVectorNorm <- typesVector/nmLen*normMax

# if "saveFile", than save as png image:
if (saveFile) png(paste(file, "png", sep="."), width=700, height=700)

#Draw Plot


barplot(typesVector,
     col="lightskyblue",
     names.arg = projTypesLab,
     main="What is the type of your FOSS project?",     
     xlab="Type of FOSS project", 
     ylab="Number of participants",
     ylim = c(0,50))     

grid(3, NULL)

pie(typesVector, 
    labels = paste(projTypes, " (", typesVector,")", sep=""), 
    col = rainbow(length(typesVector)), 
    main="What is the type of your FOSS project?", 
    radius = 0.9)

# if "saveFile", stop output-redirection to file
if (saveFile) dev.off()

}

fossanalyze.type_of_project (TRUE)
